diff -uwr source/scripts/scud.h 4.0/source/scripts/scud.h
--- source/scripts/scud.h	2010-04-14 10:13:28.000000000 +0800
+++ 4.0/source/scripts/scud.h	2011-10-14 22:27:31.965820300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by E!
-	Copyright 2010 E!, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class SCUD_Turret_Spawn : public ScriptImpClass {
 	int turID;
 	void Created(GameObject *obj);
diff -uwr source/scripts/sh_blocker.cpp 4.0/source/scripts/sh_blocker.cpp
--- source/scripts/sh_blocker.cpp	2010-04-04 10:35:04.000000000 +0800
+++ 4.0/source/scripts/sh_blocker.cpp	2011-10-11 23:06:19.515625000 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 
 #include "scripts.h"
diff -uwr source/scripts/sh_underground.cpp 4.0/source/scripts/sh_underground.cpp
--- source/scripts/sh_underground.cpp	2011-04-10 11:42:18.000000000 +0800
+++ 4.0/source/scripts/sh_underground.cpp	2011-10-11 23:06:17.741210900 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 
 #include "scripts.h"
@@ -117,6 +128,8 @@
 		// only movable objects can play
 		if (!movable_phys) return;
 
+		if (movable_phys->Is_Immovable()) return;
+
 		// no weapon firing is allowed
 		{
 			VehicleGameObj* vehicle = owner->As_VehicleGameObj();
diff -uwr source/scripts/shawk.cpp 4.0/source/scripts/shawk.cpp
--- source/scripts/shawk.cpp	2011-06-12 20:51:20.000000000 +0800
+++ 4.0/source/scripts/shawk.cpp	2011-10-11 23:06:16.314453100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by Mark "Saberhawk" Sararu
-	Copyright 2010 Mark "Saberhawk" Sararu, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -150,6 +149,14 @@
 	}
 };
 
+class SH_SoldierCantDriveVehicles: public ScriptImpClass
+{
+	void Created(GameObject* obj)
+	{
+		if (SoldierGameObj* sobj = obj->As_SoldierGameObj()) sobj->Set_Can_Drive_Vehicles(false);
+	}
+};
+
 class SH_HurtUnitTimer: public ScriptImpClass
 {
 	float time;
@@ -338,6 +345,7 @@
 REGISTER_SCRIPT(SH_VehicleStealthedWhileEmpty, "");
 REGISTER_SCRIPT(SH_VehicleCanBeStolen, "");
 REGISTER_SCRIPT(SH_SoldierCanStealVehicles, "");
+REGISTER_SCRIPT(SH_SoldierCantDriveVehicles, "");
 REGISTER_SCRIPT(SH_HurtUnitTimer, "Time:float,Warhead:string,Amount:float");
 REGISTER_SCRIPT(SH_HurtUnitTimerZone, "Time:float,Warhead:string,Amount:float");
 REGISTER_SCRIPT(SH_DangerWarning, "Time:float,TransitionIn:float,TransitionOut:float,Color:string");
diff -uwr source/scripts/shawk.h 4.0/source/scripts/shawk.h
--- source/scripts/shawk.h	2010-04-14 10:13:28.000000000 +0800
+++ 4.0/source/scripts/shawk.h	2011-10-14 22:27:32.140625000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by Mark "Saberhawk" Sararu
-	Copyright 2010 Mark "Saberhawk" Sararu, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class SH_ConsoleCommand : public ScriptImpClass {
 	void Created(GameObject *sender);
 	void Timer_Expired(GameObject *sender,int number);
diff -uwr source/scripts/straw.cpp 4.0/source/scripts/straw.cpp
--- source/scripts/straw.cpp	2009-08-28 11:37:46.000000000 +0800
+++ 4.0/source/scripts/straw.cpp	2011-10-11 23:06:13.116210900 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 #include "engine_io.h"
 #include "straw.h"
diff -uwr source/scripts/straw.h 4.0/source/scripts/straw.h
--- source/scripts/straw.h	2010-05-31 13:36:38.000000000 +0800
+++ 4.0/source/scripts/straw.h	2011-10-12 09:16:51.114257800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE__STRAW_H
 #define TT_INCLUDE__STRAW_H
 
diff -uwr source/scripts/survival.cpp 4.0/source/scripts/survival.cpp
--- source/scripts/survival.cpp	2010-04-14 10:13:24.000000000 +0800
+++ 4.0/source/scripts/survival.cpp	2011-10-11 23:06:11.570312500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for Survival stuff
-	Copyright 2010 Spirit, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/survival.h 4.0/source/scripts/survival.h
--- source/scripts/survival.h	2010-04-14 10:13:28.000000000 +0800
+++ 4.0/source/scripts/survival.h	2011-10-14 22:27:31.983398400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for Survival stuff
-	Copyright 2010 Spirit, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class SUR_Spawn_Delay : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwr source/scripts/tcw_building.cpp 4.0/source/scripts/tcw_building.cpp
--- source/scripts/tcw_building.cpp	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_building.cpp	2011-10-14 22:25:11.481445300 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -20,6 +20,10 @@
 {
 	alive = true;
 	playdamage = true;
+	if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Command_Post") == 0)
+	{
+		Commands->Set_Animation(obj,"V_GDI_CPOST.V_GDI_CPOST",true,0,1,-1,0);
+	}
 }
 void tcw_building::Killed(GameObject *obj, GameObject *shooter)
 {
@@ -30,6 +34,12 @@
 		Create_2D_WAV_Sound_Team("gdi_barracks_destroyed_nod.wav",0);
 		Send_Message(255,255,255,"GDI Barracks destroyed.");
 	}
+	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Airfield") == 0)
+	{
+		Create_2D_WAV_Sound_Team("gdi_airfield_destroyed_gdi.wav",1);
+		Create_2D_WAV_Sound_Team("gdi_airfield_destroyed_nod.wav",0);
+		Send_Message(255,255,255,"GDI Airfield destroyed.");
+	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_War_Factory") == 0)
 	{
 		Create_2D_WAV_Sound_Team("gdi_warfactory_destroyed_gdi.wav",1);
@@ -81,6 +91,21 @@
 		Send_Message_Team(1,255,255,255,"Nod Airfield destroyed.");
 		Send_Message_Team(0,255,255,255,"Nod Air Control Tower destroyed.");
 	}
+	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Command_Post") == 0)
+	{
+		Create_2D_WAV_Sound_Team("gdi_operctr_destroyed_gdi.wav",1);
+		Create_2D_WAV_Sound_Team("nod_operctr_destroyed_nod.wav",0);
+		Send_Message(255,255,255,"GDI Command Post destroyed.");
+		Commands->Set_Animation(obj,"V_GDI_CPOST.V_GDI_CPOST",true,0,1,1,0);
+		Enable_Base_Radar(1,false);
+	}
+	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Oper_Centre") == 0)
+	{
+		Create_2D_WAV_Sound_Team("gdi_operctr_destroyed_gdi.wav",1);
+		Create_2D_WAV_Sound_Team("nod_operctr_destroyed_nod.wav",0);
+		Send_Message(255,255,255,"GDI Command Post destroyed.");
+		Enable_Base_Radar(0,false);
+	}
 }
 void tcw_building::Damaged(GameObject *obj, GameObject *damager, float damage)
 {
@@ -88,7 +113,7 @@
 	{
 		if (playdamage)
 		{
-			if (damage > 1.0f)
+			if (damage > 0.5f)
 			{
 				playdamage = false;
 				Commands->Start_Timer(obj,this,25.0f,100100);
@@ -99,6 +124,13 @@
 					Send_Message_Team(0,255,255,255,"GDI Tiberium Refinery under attack.");
 					Send_Message_Team(1,255,255,255,"Warning GDI Tiberium Refinery under attack.");
 				}
+				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Airfield") == 0)
+				{
+					Create_2D_WAV_Sound_Team("gdi_airfield_under_attack_gdi.wav",1);
+					Create_2D_WAV_Sound_Team("gdi_airfield_under_attack_nod.wav",0);
+					Send_Message_Team(0,255,255,255,"GDI Airfield under attack.");
+					Send_Message_Team(1,255,255,255,"Warning GDI Airfield under attack.");
+				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_War_Factory") == 0)
 				{
 					Create_2D_WAV_Sound_Team("gdi_warfactory_under_attack_gdi.wav",1);
@@ -162,6 +194,20 @@
 					Send_Message_Team(0,255,255,255,"Warning Nod Air Control Tower under attack.");
 					Send_Message_Team(1,255,255,255,"Nod Airfield under attack.");
 				}
+				else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Armory") == 0) ||
+					(strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Silo") == 0) || 
+					(strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_CmdPost") == 0) )
+				{
+					Create_2D_WAV_Sound_Team("gdi_our_base_under_attack.wav",1);
+					Send_Message_Team(1,255,255,255,"Our Base is under attack.");
+				}
+				else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Shrine") == 0) || 
+					(strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Silo") == 0) || 
+					(strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_OpCtr") == 0) )
+				{
+					Create_2D_WAV_Sound_Team("nod_our_base_under_attack.wav",0);
+					Send_Message_Team(0,255,255,255,"Our Base is under attack.");
+				}
 			}
 		}
 	}
@@ -206,6 +252,8 @@
 {
 	if (play)
 	{
+		if (damage > 0.5f)
+		{
 		play = false;
 		Commands->Start_Timer(obj,this,25.0f,100100);
 		Create_2D_WAV_Sound_Team("gdi_watchtower_under_attack_gdi.wav",1);
@@ -214,6 +262,7 @@
 		Send_Message_Team(0,255,255,255,"GDI Watch Tower under attack.");
 	}
 }
+}
 void tcw_watchtower::Killed(GameObject *obj, GameObject *shooter)
 {
 	Create_2D_WAV_Sound_Team("gdi_watchtower_destroyed_gdi.wav",1);
diff -uwr source/scripts/tcw_building.h 4.0/source/scripts/tcw_building.h
--- source/scripts/tcw_building.h	2011-08-30 08:02:00.000000000 +0800
+++ 4.0/source/scripts/tcw_building.h	2011-10-14 22:27:32.042968700 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,6 +11,7 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class tcw_building : public ScriptImpClass {
 	void Created(GameObject *obj);
Only in 4.0/source/scripts: tcw_center_point.cpp
Only in 4.0/source/scripts: tcw_center_point.h
Only in 4.0/source/scripts: tcw_coop.cpp
Only in 4.0/source/scripts: tcw_coop.h
Only in 4.0/source/scripts: tcw_coop_cruising.cpp
Only in 4.0/source/scripts: tcw_coop_cruising.h
Only in 4.0/source/scripts: tcw_defence.cpp
Only in 4.0/source/scripts: tcw_defence.h
Only in 4.0/source/scripts: tcw_domination.cpp
Only in 4.0/source/scripts: tcw_domination.h
